//This code checks for button presses
right = keyboard_check(vk_right) or keyboard_check(ord("D"));
left = keyboard_check(vk_left) or keyboard_check(ord("A"));
up = keyboard_check(vk_up) or keyboard_check(ord("W"));
down = keyboard_check(vk_down) or keyboard_check(ord("S"));

//ups the dtickcnt to start from 0 so the player cannot spam the attack button
if (dtickcnt != 40) {
	dtickcnt += 1;
}

//this constantly updates the nearest enemy to do damage to
nearest = instance_nearest(x, y, oEnemy);
ifollowing = instance_nearest(x, y, oSatan);


//This code balances the left or right and up or down presses
inputX = right - left;
inputY = down - up;
moveX = inputX * moveSpeed;
moveY = inputY * moveSpeed;

//the below code deals with rotation of the player
if (right){
	image_angle = 270;
}
if (down){
	image_angle = 180;
}
if (left){
	image_angle = 90;
}
if (up){
	image_angle = 0;
}
if (right and up){
	image_angle = 315;
}
if (right and down){
	image_angle = 225;
}
if (left and up){
	image_angle = 45;
}
if (left and down){
	image_angle = 135;
}
direction = image_angle + 90;

//This if statement checks for collision against a Wall object.
if (not place_meeting(x + moveX, y + moveY, oObstacle)){
	//These two lines are the movement code.
	x += moveX;
	y += moveY;
}
//rotation code ends here

//Red Healthbar Set Code

if (redBar > health) {
	redBar -= min((redBar - health) / 30, 1);
}
else if (redBar < health) {
	redBar = health
}
if (health < 0){
	health = 0;
}
//Death Code
if health == 0 and room == rInstructions {
	health = 100;
}
else if (health == 0 and global.isInHell){
	room_goto(rDeathDeath);
}
else if (health == 0) {
	global.isInHell = true;
	room_goto(rDeath);
}

//The below two if statements are the teleportation code.
if (instance_exists(oTeleportation)){
	teleportation = instance_nearest(x, y, oTeleportation);//This locks onto the singular instance of the teleportation thing.
	if (keyboard_check_pressed(vk_space)){
		health -= warpCost;
		x = teleportation.x;
		y = teleportation.y;
		visionCircle.x = x;
		visionCircle.y = y;
		instance_destroy(teleportation);
		exit;
	}
}

if (keyboard_check_pressed(vk_space) and alarm[0] < 0){
	instance_create_layer(x, y, "Instances", oTeleportation);
}

//Healing code
if (keyboard_check_pressed(ord("F")) and health < 100){
	if (instance_exists(oTeleportation)){
		instance_destroy(teleportation);
	}
	moveSpeed = 1;
	alarm[0] = 12;
}

//Health Potion
else if (keyboard_check_pressed(ord("E")) and oInventory.hasHealingPot){
	InventoryRemove(InventorySearch(3) + 1);
	health = 100;
	oInventory.hotbarSlot = 0;
}

//this does damage to the nearest enemy when they are in range and when
if (mouse_check_button_pressed(mb_left) and instance_exists(oEnemy) and instance_exists(oSatan) and alarm[0] < 0 and !instance_exists(oTeleportation) and dtickcnt == 40) {
	if (point_distance(oPlayer.x, oPlayer.y, nearest.x, nearest.y)) <= (point_distance(oPlayer.x, oPlayer.y, ifollowing.x, ifollowing.y)) {
		if (point_distance(x, y, nearest.x, nearest.y) <= 200) {
			if (oInventory.isHoldingNothing == true or oInventory.hasSword == true or oInventory.hasSuperSword == true) {
				nearest.enemy_h -= global.damage;
				global.totalDamage += global.damage;
				dtickcnt = 0;
			}
		}
	}
	else {
		if (point_distance(x, y, ifollowing.x, ifollowing.y) <= 200) {
			if (oInventory.hasSuperSword == true) {
				ifollowing.bhealth -= global.damage;
				global.totalDamage += global.damage;
				dtickcnt = 0;
			}
			else if (oInventory.isHoldingNothing == true or oInventory.hasSword == true) {
				ifollowing.bhealth -= 1;
				global.totalDamage++;
				dtickcnt = 0;
			}
		}
	}

	
}
else if (mouse_check_button_pressed(mb_left) and instance_exists(oEnemy) and alarm[0] < 0 and !instance_exists(oTeleportation) and dtickcnt == 40) {
	if (point_distance(x, y, nearest.x, nearest.y) <= 200) {
		if (oInventory.isHoldingNothing == true or oInventory.hasSword == true or oInventory.hasSuperSword == true) {
			nearest.enemy_h -= global.damage;
			global.totalDamage += global.damage;
			dtickcnt = 0;
		}
	}
}
else if (mouse_check_button_pressed(mb_left) and instance_exists(oSatan) and alarm[0] < 0 and !instance_exists(oTeleportation) and dtickcnt == 40) {
	if (point_distance(x, y, ifollowing.x, ifollowing.y) <= 200) {
		if (oInventory.hasSuperSword == true) {
			ifollowing.bhealth -= global.damage;
			global.totalDamage += global.damage;
			dtickcnt = 0;
		}
		else if (oInventory.isHoldingNothing == true or oInventory.hasSword == true) {
			ifollowing.bhealth -= 1;
			global.totalDamage++;
			dtickcnt = 0;
		}
	}
}

if (alarm < 0){
	moveSpeed = 4;
}
//code for music:
if (room == r00){
	if (audio_is_playing(soOverworld) == false){audio_play_sound(soOverworld,1,true);}
}

if (room == rHell){
	if (hasStoppedoverworldmusic == false){
		audio_stop_all()
		hasStoppedoverworldmusic = true;
	}

	if (audio_is_playing(soHell) == false){
		audio_play_sound(soHell,1,true);
	}
}

if (keyboard_check_pressed(ord("Y")) and alarm[0] < 0){
	room_goto(rBossBattle);
}