distance = 10;
check_x = id.x + lengthdir_x(distance, id.image_angle + 90);
check_y = id.y + lengthdir_y(distance, id.image_angle + 90);
//The below code all executes when the enemy locks onto a player.
if (distance_to_point(oPlayer.x, oPlayer.y) < 300) {
	alarm[0] = -1;
	speed = 0;
	alarmOn = false;
	if (place_meeting(check_x, check_y, oEnemy)) {//This is the anti overlap code.
		var count = 10
		var nearest = instance_nearest(id.x + lengthdir_x(count, id.image_angle + 90), id.y + lengthdir_y(count, id.image_angle + 90), oEnemy);
		while (nearest == id){
			var nearest = instance_nearest(id.x + lengthdir_x(count, id.image_angle + 90), id.y + lengthdir_y(count, id.image_angle + 90), oEnemy);
			count++;
		}
		id.enemy_h += nearest.enemy_h;
		id.initial_enemy_h += nearest.enemy_h;
		id.damage += nearest.damage;
		id.size = (id.size + nearest.size) * 0.75;
		if (size > maxSize){
			id.size = maxSize;
		}
		instance_destroy(nearest);
	}
	else if (not place_meeting(id.x + lengthdir_x(3, id.image_angle + 90), id.y + lengthdir_y(3, id.image_angle + 90), oObstacle)) {
		//Tracking the player code
		if (distance_to_point(oPlayer.x, oPlayer.y) < 3){
			move_towards_point(oPlayer.x, oPlayer.y, distance_to_point(oPlayer.x, oPlayer.y));
		}
		else {
			move_towards_point(oPlayer.x, oPlayer.y, 3);
		}
		image_angle = point_direction(oPlayer.x, oPlayer.y, id.x, id.y) + 90;
	}
}
if (not alarmOn){
	alarmOn = true;
	alarm[0] = 6;
}

//This code is for the idle collision
if (place_meeting(id.x + lengthdir_x(3, id.image_angle + 90), id.y + lengthdir_y(3, id.image_angle + 90), oObstacle)){
	speed = 0;
}


//This code sets the visibility float for the visibility code.
if (global.isInHell){
	visibilityFloat = (sightrange - point_distance(oLightParent.x, oLightParent.y, x, y))/ 100;
}
else {
	visibilityFloat = 1;
}

if(enemy_h <= 0){
	instance_destroy();
}